' This project was adapted from AMR Bekhit's VB template with permission for the DIRECTEMP(TM) HID product
' all deviations from that project are (C) 2008 QTI, all rights reserved

Imports System
Imports System.Text
Imports System.Drawing
Imports System.Math
Imports System.IO

Public Class frmMain
    ' vendor and product IDs
    Private Const VendorID As Short = &H1DFD        'QTI VID
    Private Const ProductID As Short = &H2          'DIRECTEMP(TM) HID PID

    ' read and write buffers
    Private Const BufferInSize As Short = 16        'Size of the data buffer coming IN to the PC
    Private Const BufferOutSize As Short = 16       'Size of the data buffer going OUT from the PC
    Dim BufferIn(BufferInSize) As Byte              'Received data will be stored here - the first byte in the array is unused
    Dim BufferOut(BufferOutSize) As Byte            'Transmitted data is stored here - the first item in the array must be 0
    Dim inputbuffer As String
    Dim mode As Integer
    Dim button As Object
    Dim Ecode As System.EventArgs
    Dim ManBuffer As String

    ' ****************************************************************
    ' when the form loads, connect to the HID controller - pass
    ' the form window handle so that you can receive notification
    ' events...
    '*****************************************************************
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' do not remove!
        ConnectToHID(Me)
        mode = 0
    End Sub
    '*****************************************************************
    ' disconnect from the HID controller...
    '*****************************************************************
    Private Sub Form1_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
        DisconnectFromHID()
    End Sub
    '*****************************************************************
    ' a HID device has been plugged in...
    '*****************************************************************
    Public Sub OnPlugged(ByVal pHandle As Integer)
        'tsStatus.Text = "dev plug"
        If hidGetVendorID(pHandle) = VendorID And hidGetProductID(pHandle) = ProductID Then
            lConnect.Text = "CONNECTED"
            ' ** YOUR CODE HERE **
            Send("4")
            mode = 5
            If hidIsReadNotifyEnabled(pHandle) = False Then
                hidSetReadNotify(pHandle, True)
            End If
        End If
    End Sub
    '*****************************************************************
    ' a HID device has been unplugged...
    '*****************************************************************
    Public Sub OnUnplugged(ByVal pHandle As Integer)
        'tsStatus.Text = "dev unplug"
        If hidGetVendorID(pHandle) = VendorID And hidGetProductID(pHandle) = ProductID Then
            hidSetReadNotify(hidGetHandle(VendorID, ProductID), False)
            lConnect.Text = "Not Connected"
            ' ** YOUR CODE HERE **
        End If
    End Sub
    '*****************************************************************
    ' controller changed notification - called
    ' after ALL HID devices are plugged or unplugged
    '*****************************************************************
    Public Sub OnChanged()
        'tsStatus.Text = "dev chng"
        ' get the handle of the device we are interested in, then set
        ' its read notify flag to true - this ensures you get a read
        ' notification message when there is some data to read...
        Dim pHandle As Integer
        pHandle = hidGetHandle(VendorID, ProductID) ' get handle for USB device (only one at a time can be used)
        hidSetReadNotify(hidGetHandle(VendorID, ProductID), True) 'set up notification from device
    End Sub
    '*****************************************************************
    ' The HID API calls this function when a Read Event has occured
    ' and data has been read from the HID device.  The data is available
    ' in the BufferIn() array.  The first byte, ie, BufferIn(0) is the
    ' Report ID.  The actual data from the HID device is available in
    ' BufferIn(1)...
    '*****************************************************************
    Public Sub OnRead(ByVal pHandle As Integer) ' as data from device is received
        'Dim statusDummy As Byte
        Dim i As Integer ' i is for mode and counting purposes
        'tsStatus.Text = "Msg Received"
        ' read the data (don't forget, pass the whole array)... how do we do that? -- see for statement?
        If hidRead(pHandle, BufferIn(0)) Then 'and added the for loop... it does not work.
            i = 1 ' i = 1 for beginning state machine
            Dim DataIn As String ' data in is the string that will be used to collect the ascii characters
            DataIn = "" ' reset data in
            Select Case Chr(Int(BufferIn(1))) ' convert buffer 1 element number value to a string and then that string to a character
                '*****************************
                'receive temperature
                ' use do loop to gather buffer
                '*****************************
                Case "2" ' 1
                    i = 2 ' i is element counter
                    Do
                        If BufferIn(i) <> 0 Then
                            DataIn += Chr(Int(BufferIn(i)))
                        End If
                        If i > 16 Then
                            Exit Do
                        End If
                        i = i + 1
                    Loop While i < 17
                    tbTemp.Text = DataIn
                    ManBuffer = DataIn
                    '*****************************
                    'receive information
                    'use for loop to gather buffer
                    '*****************************
                Case "3" ' 3
                    For i = 2 To 16
                        If BufferIn(i) <> 0 Then
                            DataIn += Chr(Int(BufferIn(i)))
                        End If
                    Next
                    If InStr(DataIn, Chr(13)) Then 'if there is a CR character, the line is finished
                        tbInput.Text += DataIn
                        ManBuffer = tbInput.Text
                        tbAll.Text += ManBuffer
                        tbInput.Text = Nothing
                        If InStr(1, ManBuffer, "v.", CompareMethod.Text) Then
                            lFirmware.Text = Mid(ManBuffer, Len(ManBuffer) - 5)
                        End If
                        If InStr(1, ManBuffer, "brate ", CompareMethod.Text) Then
                            lCalibrate.Text = Mid(ManBuffer, InStr(1, ManBuffer, " ", CompareMethod.Text))
                        End If
                        tbInput.Text = ""
                    Else
                        tbInput.Text += DataIn ' just add the data to the que
                    End If
                    ' End If
                Case "4" ' 4 Serial number only
                    i = 2
                    Do
                        If BufferIn(i) <> 0 Then
                            DataIn += Chr(Int(BufferIn(i)))
                        End If
                        If i > 16 Then
                            Exit Do
                        End If
                        i = i + 1
                    Loop While i < 17
                    If InStr(DataIn, Chr(13)) Then 'check for carriage return
                        tbInput.Text += DataIn
                        ManBuffer = tbInput.Text
                        lSerial.Text = Mid(ManBuffer, Len(ManBuffer) - 8, 8)
                        tbAll.Text = tbAll.Text + ManBuffer
                        tbInput.Text = ""
                    Else
                        tbInput.Text = DataIn 'if no CR then add data to last input stuff
                    End If
            End Select
        End If
        On Error GoTo LocalHandler
        Exit Sub
LocalHandler:
        MsgBox("Unexpected communication", MsgBoxStyle.OkOnly, "USB Error")
        Resume Next
    End Sub
    '*****************************************************************
    ' Click on the button for a single temperature reading
    '*****************************************************************
    Private Sub bSingle_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bSingle.Click
        'Send(&h50)
        Send("2")
    End Sub
    '*****************************************************************
    ' Click on the button for a probe information:
    ' firmware version
    ' calibration date
    ' web info
    '*****************************************************************
    Private Sub bInfo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bInfo.Click
        'Send(&h51)
        Send("3")
    End Sub
    '*****************************************************************
    ' Click on the button for a the device serial number
    '*****************************************************************
    Private Sub bSerial_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bSerial.Click
        'Send(&h52)
        Send("4")
    End Sub
    '*****************************************************************
    ' Takes send string, converts it to ascii decimal
    ' puts it in the send buffer array and writes it to the HID device
    '*****************************************************************
    Private Sub Send(ByVal text As String)
        Dim i As Integer
        For i = 1 To 16
            If i <= text.Length Then
                BufferOut(i) = Byte.Parse(Asc(Mid(text, i, 1)).ToString)
            Else
                BufferOut(i) = Byte.Parse(0)
            End If
        Next
        Try
            hidWriteEx(VendorID, ProductID, BufferOut(0))
        Catch ex As Exception
            MsgBox(ex, MsgBoxStyle.Information, "Error")
        End Try
    End Sub
    '*****************************************************************
    ' clears the readout text box
    '*****************************************************************
    Private Sub bClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bClear.Click
        tbAll.Clear()
    End Sub
    '*****************************************************************
    ' Check the box that enables or disables continuing timed
    ' temperature data acquisition
    '*****************************************************************
    Private Sub cbTemp_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbTemp.CheckedChanged
        If cbTemp.Checked = True Then
            Timer1.Enabled = True
            bReset_Click(sender, e)
            mode = 1
        Else
            mode = 0
            Timer1.Enabled = False
        End If
        On Error GoTo LocalHandler
        Exit Sub
        On Error GoTo LocalHandler
        Exit Sub
LocalHandler:
        MsgBox("Unable to stream data", MsgBoxStyle.OkOnly, "Checkbox event Error")
    End Sub
    '*****************************************************************
    ' Clears the buffers, and text boxes
    '*****************************************************************
    Private Sub bReset_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        ManBuffer = Nothing
        tbAll.Text = Nothing
        tbInput.Text = Nothing
        On Error GoTo LocalHandler
        Exit Sub
LocalHandler:
        MsgBox("Unexpected reset response", MsgBoxStyle.OkOnly, "Error")
    End Sub
    '*****************************************************************
    ' Click the button to get one temperature point
    '*****************************************************************
    Private Sub bGet1Temp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        bReset_Click(sender, e)
        mode = 1
        Send("2")
        On Error GoTo LocalHandler
        Exit Sub
LocalHandler:
        MsgBox("Error updating chart for temperature", MsgBoxStyle.OkOnly, "Chart Error")
    End Sub
    '*****************************************************************
    ' Timer event handling routing for successive temperature readings
    '*****************************************************************
    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        If mode = 1 Then
            Send("2")
        Else
            Timer1.Enabled = False
            'tbTemp.Text = "ERR"
        End If
    End Sub
End Class
